// HW2 -- count char, int, float, double, and void declarations
// Jim Fawcett, CSE687

#include <fstream.h>  // fstream includes iostream
#include <stdlib.h>   // defines exit()
#include <string.h>   // defines strcmp()

void main(int argc, char *argv[]) {

  if (argc < 2) {  // argc counts number of argv's
    cerr << "please enter file name on command line\n";
    exit(1);
  }
  ifstream istrm(argv[1]);
  if (!istrm) {    // istrm will be null if can't open file
    cerr << "can't open " << argv[1] << "\n";
    exit(1);
  }

  struct counter { // here's where we save the declar counts
    int chrs;
    int ints;
    int flts;
    int dbls;
    int vds;
  } count = { 0,0,0,0,0 };

  #define MAXSIZE 256       // longest line we'll deal with
  char line[MAXSIZE];
  #define LINESIZE 80       // text line length on IBMPC clones
  char blanker[LINESIZE];
  for (int j=0; j<LINESIZE; j++)
    blanker[j] = ' ';
  blanker[LINESIZE-1] = '\0';

  long int prev_pos, pos = 0;
  while (istrm.getline(line, MAXSIZE)) {

  // getline fails to return null if last line has no "\n"
  // so we'll fix by aborting if file position doesn't change
    prev_pos = pos;
    pos = istrm.tellg();
    if (pos == prev_pos)
      break;
    else
      prev_pos = pos;

  // write lines to terminal to show user that program is thinking
    cerr << blanker << "\r";
    cerr << line << "\r";
/**/
  // scan line looking for chars, ints, floats, and doubles
    int len = strlen(line);
    for (int i=0; i<len; i++)
      if (strncmp(line+i,"char ",5) == 0) count.chrs++;
      else if (strncmp(line+i,"int ",4) == 0) count.ints++;
      else if (strncmp(&line[i],"float ",6) == 0) count.flts++;
      else if (strncmp(&line[i],"double ",7) == 0) count.dbls++;
      else if (strncmp(line+i,"void ",5) == 0) count.vds++;
  }
  cerr << blanker << "\r";

  cout << "\nHW2: Statistics for primitive types in "
       << argv[1] << " are:\n\n";
  cout << "  # chars   = " << count.chrs << "\n";
  cout << "  # ints    = " << count.ints << "\n";
  cout << "  # floats  = " << count.flts << "\n";
  cout << "  # doubles = " << count.dbls << "\n";
  cout << "  # voids   = " << count.vds  << "\n";
}

/*
   Could speed up processing by defining our own strncmp function
   as inline to avoid the overhead of many function calls which
   will return as soon as the first character examined fails to
   match.
*/